Bug 1312489 - Wrong GOT offset used with GOT relocation
Wrong GOT offset used with GOT relocation
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: binutils (Show other bugs)
24
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Nick Clifton
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-02-26 16:24 EST by H.J. Lu
Modified: 2017-08-08 09:04 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-08-08 09:04:43 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Sourceware 19601 None None None 2016-02-26 16:24 EST

  None (edit)
Description H.J. Lu 2016-02-26 16:24:38 EST
Since commit 02a866936de7e63ad4962ccba56c8cd05c231275 ld generates invalid GOT entries (less than 4 Byte in size) when processing a R_386_GOT32X relocation to a weak symbol during static linking.  This happens for example when statically linking a C++ program without using libpthread on Linux.

It has been fixed on 2.26 branch by

https://sourceware.org/git/gitweb.cgi?p=binutils-gdb.git;h=32875eb1f3b928dfe63c5752e8152a9dc09928f3

commit 32875eb1f3b928dfe63c5752e8152a9dc09928f3
Author: H.J. Lu <hjl.tools@gmail.com>
Date:   Wed Feb 10 19:33:52 2016 -0800

    Mask off the least significant bit in GOT offset
    
    The least significant bit in GOT offset is to record whether we have
    initialized the GOT entry in R_386_GOT32 processing.  We need to mask
    it off for R_386_GOT32X.
    
    	PR ld/19601
    	* elf32-i386.c (elf_i386_relocate_section): Mask off the least
    	significant bit in GOT offset for R_386_GOT32X.
Comment 1 Nick Clifton 2016-02-29 11:23:42 EST
Patch checked in:

  binutils-2.26-14.fc25
  binutils-2.26-14.fc24
Comment 2 Fedora End Of Life 2017-07-25 16:15:30 EDT
This message is a reminder that Fedora 24 is nearing its end of life.
Approximately 2 (two) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 24. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '24'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 24 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.
Comment 3 Fedora End Of Life 2017-08-08 09:04:43 EDT
Fedora 24 changed to end-of-life (EOL) status on 2017-08-08. Fedora 24 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.